﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfApplication1
{
    public class TestViewModel : INotifyPropertyChanged
    {
        protected bool? allowEdit;
        public bool? AllowEdit
        {
            get { return allowEdit; }
            set
            {
                if (!Object.Equals(value, allowEdit))
                {
                    allowEdit = value;
                    OnPropertyChanged("AllowEdit");
                }
            }
        }

        private ObservableCollection<TestData> collection = new ObservableCollection<TestData>() { new TestData() { ParameterName = "1" }, new TestData() { ParameterName = "2" } };
        public ObservableCollection<TestData> Collection
        {
            get { return collection; }
        }

        public TestViewModel()
            : base()
        { }

        public event PropertyChangedEventHandler PropertyChanged = delegate { };
        private void OnPropertyChanged(string property)
        {
            PropertyChanged(this, new PropertyChangedEventArgs(property));
        }
    }

    public class TestData : INotifyPropertyChanged
    {
        public TestData()
        { }

        private bool isSelectedInGrid = false;
        public bool IsSelectedInGrid
        {
            get { return isSelectedInGrid; }
            set
            {
                if (isSelectedInGrid != value)
                {
                    isSelectedInGrid = value;
                    OnPropertyChanged("IsSelectedInGrid");
                }
            }
        }

        protected string parameterName;
        public string ParameterName
        {
            get { return parameterName; }
            set
            {
                if (!Object.Equals(value, parameterName))
                {
                    parameterName = value;
                    OnPropertyChanged("ParameterName");
                }
            }
        }

        protected string parameterValue;
        public string ParameterValue
        {
            get { return parameterValue; }
            set
            {
                if (!Object.Equals(value, parameterValue))
                {
                    parameterValue = value;
                    OnPropertyChanged("ParameterValue");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged = delegate { };
        private void OnPropertyChanged(string property)
        {
            PropertyChanged(this, new PropertyChangedEventArgs(property));
        }
    }
}
